diff --git a/src/main/java/net/minecraft/client/world/chunk/provider/ChunkProviderStatic.java b/src/main/java/net/minecraft/client/world/chunk/provider/ChunkProviderStatic.java
index eb7aaa0e8..d29bd8e4d 100644
--- a/src/main/java/net/minecraft/client/world/chunk/provider/ChunkProviderStatic.java
+++ b/src/main/java/net/minecraft/client/world/chunk/provider/ChunkProviderStatic.java
@@ -1,5 +1,7 @@
 package net.minecraft.client.world.chunk.provider;
 
+import com.mojang.logging.LogUtils;
+import net.minecraft.core.Global;
 import net.minecraft.core.world.ProgressListener;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.chunk.Chunk;
@@ -7,6 +9,7 @@ import net.minecraft.core.world.chunk.EmptyChunk;
 import net.minecraft.core.world.chunk.IChunkLoader;
 import net.minecraft.core.world.chunk.provider.IChunkProvider;
 import net.minecraft.core.world.generate.chunk.ChunkGenerator;
+import org.slf4j.Logger;
 
 import java.io.IOException;
 import java.util.Arrays;
@@ -18,12 +21,24 @@ import java.util.Arrays;
 public class ChunkProviderStatic
     implements IChunkProvider
 {
+    private static final Logger LOGGER = LogUtils.getLogger();
+    private final Chunk blankChunk;
+    public ChunkGenerator chunkGenerator;
+    private final IChunkLoader chunkLoader;
+    private final Chunk[] chunks;
+    private final World worldObj;
+    int lastQueriedChunkXPos;
+    int lastQueriedChunkZPos;
+    private Chunk lastQueriedChunk;
+    private int curChunkX;
+    private int curChunkY;
+
 
     public ChunkProviderStatic(World world, IChunkLoader ichunkloader, ChunkGenerator chunkGenerator)
     {
         chunks = new Chunk[1024];
-        lastQueriedChunkXPos = 0xc4653601;
-        lastQueriedChunkZPos = 0xc4653601;
+        lastQueriedChunkXPos = Integer.MIN_VALUE;
+        lastQueriedChunkZPos = Integer.MIN_VALUE;
         blankChunk = new EmptyChunk(world, 0, 0);
         worldObj = world;
         chunkLoader = ichunkloader;
@@ -170,7 +185,7 @@ public class ChunkProviderStatic
         return chunks[i1];
     }
 
-    private Chunk loadChunk(int i, int j)
+    private Chunk loadChunk(int chunkX, int chunkZ)
     {
         if(chunkLoader == null)
         {
@@ -178,7 +193,7 @@ public class ChunkProviderStatic
         }
         try
         {
-            Chunk chunk = chunkLoader.loadChunk(worldObj, i, j);
+            Chunk chunk = chunkLoader.loadChunk(worldObj, chunkX, chunkZ);
             if(chunk != null)
             {
                 chunk.lastSaveTime = worldObj.getWorldTime();
@@ -187,7 +202,7 @@ public class ChunkProviderStatic
         }
         catch(Exception exception)
         {
-            exception.printStackTrace();
+            LOGGER.error("Error loading chunk at X:{}, Z:{}", chunkX, chunkZ, exception);
         }
         return blankChunk;
     }
@@ -203,9 +218,9 @@ public class ChunkProviderStatic
             chunk.lastSaveTime = worldObj.getWorldTime();
             chunkLoader.saveChunk(worldObj, chunk);
         }
-        catch(IOException ioexception)
+        catch(IOException e)
         {
-            ioexception.printStackTrace();
+            LOGGER.error("Error saving chunk at X:{}, Z:{}", chunk.xPosition, chunk.zPosition, e);
         }
     }
 
@@ -271,7 +286,7 @@ public class ChunkProviderStatic
     {
         return false;
     }
-    
+
     @Override
     public void unloadAllChunks()
     {
@@ -292,21 +307,10 @@ public class ChunkProviderStatic
     @Override
     public String getInfoString()
     {
-        return (new StringBuilder()).append("ChunkCache: ").append(chunks.length).toString();
+        return "ChunkCache: " + chunks.length;
     }
 
     public IChunkLoader getChunkLoader() {
         return chunkLoader;
     }
-
-    private Chunk blankChunk;
-    public ChunkGenerator chunkGenerator;
-    private IChunkLoader chunkLoader;
-    private Chunk chunks[];
-    private World worldObj;
-    int lastQueriedChunkXPos;
-    int lastQueriedChunkZPos;
-    private Chunk lastQueriedChunk;
-    private int curChunkX;
-    private int curChunkY;
 }
diff --git a/src/main/java/net/minecraft/core/achievement/Achievements.java b/src/main/java/net/minecraft/core/achievement/Achievements.java
index f6448eaab..244e95ecc 100644
--- a/src/main/java/net/minecraft/core/achievement/Achievements.java
+++ b/src/main/java/net/minecraft/core/achievement/Achievements.java
@@ -1,16 +1,19 @@
 package net.minecraft.core.achievement;
 
+import com.mojang.logging.LogUtils;
 import net.minecraft.client.gui.achievements.data.AchievementPages;
+import net.minecraft.core.Global;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.item.Items;
 import net.minecraft.core.util.collection.NamespaceID;
+import org.slf4j.Logger;
 
 import java.util.ArrayList;
 import java.util.List;
 
 public abstract class Achievements
 {
-    
+    private static final Logger LOGGER = LogUtils.getLogger();
     public static List<Achievement> achievementList = new ArrayList<>();
     public static Achievement OPEN_INVENTORY =
         new Achievement(new NamespaceID("minecraft", "open_inventory"), "openInventory", 0, 0, Items.BOOK, null)
@@ -202,6 +205,6 @@ public abstract class Achievements
         if (hasInit) return;
         hasInit = true;
         AchievementPages.init();
-        System.out.println(achievementList.size() + " Achievements");
+        LOGGER.info("{} Achievements", achievementList.size());
     }
 }
diff --git a/src/main/java/net/minecraft/core/achievement/stat/StatsCounter.java b/src/main/java/net/minecraft/core/achievement/stat/StatsCounter.java
index 7508c0be3..e6da28072 100644
--- a/src/main/java/net/minecraft/core/achievement/stat/StatsCounter.java
+++ b/src/main/java/net/minecraft/core/achievement/stat/StatsCounter.java
@@ -5,6 +5,7 @@ import java.util.Collections;
 import java.util.HashMap;
 import java.util.Locale;
 import java.util.Map;
+import java.util.UUID;
 
 import com.b100.json.JsonParser;
 import com.b100.json.element.JsonArray;
@@ -12,15 +13,18 @@ import com.b100.json.element.JsonElement;
 import com.b100.json.element.JsonEntry;
 import com.b100.json.element.JsonObject;
 import com.b100.utils.FileUtils;
+import com.mojang.logging.LogUtils;
+import net.minecraft.core.Global;
 import net.minecraft.core.MD5String;
 import net.minecraft.core.achievement.Achievement;
 import net.minecraft.core.player.Session;
 import net.minecraft.core.util.HardIllegalArgumentException;
 import net.minecraft.core.util.collection.NamespaceID;
 import org.jetbrains.annotations.Unmodifiable;
+import org.slf4j.Logger;
 
 public class StatsCounter {
-
+	private static final Logger LOGGER = LogUtils.getLogger();
 	private final Map<Stat, Integer> sessionStats; // Local copy of stats used by the client
 	private final Map<Stat, Integer> savedStats;
 	private boolean modified;
@@ -132,7 +136,7 @@ public class StatsCounter {
 				if (file.getName().startsWith("stats_") && file.getName().endsWith(".dat")) {
 					File destination = new File(statsFolder, file.getName());
 					if (!destination.exists()) {
-						System.out.println("Relocating " + file.getName());
+                        LOGGER.info("Relocating {}", file.getName());
 						file.renameTo(destination);
 					}
 				}
@@ -162,31 +166,31 @@ public class StatsCounter {
 						stat = StatList.StatConverter.getStatFromDeprecatedID(Integer.parseInt(statId));
 					}
 				} catch (HardIllegalArgumentException | NumberFormatException e){
-					e.printStackTrace();
+                    LOGGER.warn("Exception parsing statID: '{}'", statId, e);
 					continue;
 				}
 
 
 				if(stat == null) {
-					System.out.println(statId + " is not a valid stat");
+                    LOGGER.warn("{} is not a valid stat", statId);
 					continue;
 				}
 				map.put(stat, value);
 			}
 		} catch (Exception e) {
-			e.printStackTrace();
+			LOGGER.error("Exception while reading stats string!", e);
 		}
 		return map;
 	}
 
-	public static String getStatFileContentString(String username, String sessionID, Map<Stat, Integer> map) {
+	public static String getStatFileContentString(UUID uuid, String sessionID, Map<Stat, Integer> map) {
 		StringBuilder displayString = new StringBuilder();
 		StringBuilder checkSumString = new StringBuilder();
 		boolean flag = true;
 		displayString.append("{\r\n");
-		if (username != null && sessionID != null) {
+		if (uuid != null && sessionID != null) {
 			displayString.append("  \"user\":{\r\n");
-			displayString.append("    \"name\":\"").append(username).append("\",\r\n");
+			displayString.append("    \"uuid\":\"").append(uuid).append("\",\r\n");
 			displayString.append("    \"sessionid\":\"").append(sessionID).append("\"\r\n");
 			displayString.append("  },\r\n");
 		}
diff --git a/src/main/java/net/minecraft/core/achievement/stat/StatsSyncher.java b/src/main/java/net/minecraft/core/achievement/stat/StatsSyncher.java
index fe8535eb8..fee7b6d4c 100644
--- a/src/main/java/net/minecraft/core/achievement/stat/StatsSyncher.java
+++ b/src/main/java/net/minecraft/core/achievement/stat/StatsSyncher.java
@@ -1,13 +1,15 @@
 package net.minecraft.core.achievement.stat;
 
 import com.b100.utils.StringUtils;
+import com.mojang.logging.LogUtils;
 import net.minecraft.core.player.Session;
+import org.slf4j.Logger;
 
 import java.io.*;
 import java.util.Map;
 
 public class StatsSyncher {
-
+    private static final Logger LOGGER = LogUtils.getLogger();
     private volatile boolean busy = false;
     private volatile Map<Stat, Integer> queuedLocalStatsChanges;
     private volatile Map<Stat, Integer> queuedSavedStatsChanges;
@@ -20,27 +22,29 @@ public class StatsSyncher {
     private final File statsFileOld;
     private final Session session;
     private int saveTimer;
-    private int fetchChangesTimer; // Im making a sorta longshot guess but I think this is the remnant of an unused timer to retrieve stat changes from the server
+    private int fetchChangesTimer; // I'm making a sorta longshot guess, but I think this is the remnant of an unused timer to retrieve stat changes from the server
 
     public StatsSyncher(Session session, StatsCounter statsCounter, File statsDir) {
         queuedLocalStatsChanges = null;
         queuedSavedStatsChanges = null;
         saveTimer = 0;
         fetchChangesTimer = 0;
-        unsentStatsFile = new File(statsDir, "stats_" + session.username.toLowerCase() + "_unsent.dat");
-        statsFile = new File(statsDir, "stats_" + session.username.toLowerCase() + ".dat");
-        unsentStatsFileOld = new File(statsDir, "stats_" + session.username.toLowerCase() + "_unsent.old");
-        statsFileOld = new File(statsDir, "stats_" + session.username.toLowerCase() + ".old");
-        unsentStatsFileTemp = new File(statsDir, "stats_" + session.username.toLowerCase() + "_unsent.tmp");
-        statsFileTemp = new File(statsDir, "stats_" + session.username.toLowerCase() + ".tmp");
-        if (!session.username.toLowerCase().equals(session.username)) {
-            renameFile(statsDir, "stats_" + session.username + "_unsent.dat", unsentStatsFile);
-            renameFile(statsDir, "stats_" + session.username + ".dat", statsFile);
-            renameFile(statsDir, "stats_" + session.username + "_unsent.old", unsentStatsFileOld);
-            renameFile(statsDir, "stats_" + session.username + ".old", statsFileOld);
-            renameFile(statsDir, "stats_" + session.username + "_unsent.tmp", unsentStatsFileTemp);
-            renameFile(statsDir, "stats_" + session.username + ".tmp", statsFileTemp);
-        }
+
+        statsFile =           (new File(statsDir, "stats_" + session.uuid + ".dat"));
+        statsFileOld =        (new File(statsDir, "stats_" + session.uuid + ".old"));
+        statsFileTemp =       (new File(statsDir, "stats_" + session.uuid + ".tmp"));
+        unsentStatsFile =     (new File(statsDir, "stats_" + session.uuid + "_unsent.dat"));
+        unsentStatsFileOld =  (new File(statsDir, "stats_" + session.uuid + "_unsent.old"));
+        unsentStatsFileTemp = (new File(statsDir, "stats_" + session.uuid + "_unsent.tmp"));
+
+        // Remap pre-UUID stats to new UUID files
+        new File(statsDir, "stats_" + session.username.toLowerCase() + ".dat").renameTo(statsFile);
+        new File(statsDir, "stats_" + session.username.toLowerCase() + ".old").renameTo(statsFileOld);
+        new File(statsDir, "stats_" + session.username.toLowerCase() + ".tmp").renameTo(statsFileTemp);
+        new File(statsDir, "stats_" + session.username.toLowerCase() + "_unsent.dat").renameTo(unsentStatsFile);
+        new File(statsDir, "stats_" + session.username.toLowerCase() + "_unsent.old").renameTo(unsentStatsFileOld);
+        new File(statsDir, "stats_" + session.username.toLowerCase() + "_unsent.tmp").renameTo(unsentStatsFileTemp);
+
         this.statsCounter = statsCounter;
         this.session = session;
         if (unsentStatsFile.exists()) {
@@ -49,10 +53,10 @@ public class StatsSyncher {
         startRetrievalThread();
     }
 
-    private void renameFile(File file, String s, File file1) {
-        File file2 = new File(file, s);
-        if (file2.exists() && !file2.isDirectory() && !file1.exists()) {
-            file2.renameTo(file1);
+    private void renameFile(File parent, String child, File fileToRename) {
+        File destFile = new File(parent, child);
+        if (destFile.exists() && !destFile.isDirectory() && !fileToRename.exists()) {
+            destFile.renameTo(fileToRename);
         }
     }
 
@@ -74,7 +78,7 @@ public class StatsSyncher {
         try {
             return StatsCounter.readStatsFromString(StringUtils.getFileContentAsString(statsFile));
         } catch (Exception e) {
-            e.printStackTrace();
+            LOGGER.warn("Failed to read stats from file '{}'!", statsFile.getPath(), e);
         }
         return null;
     }
@@ -82,7 +86,7 @@ public class StatsSyncher {
     private void saveStats(Map<Stat, Integer> map, File statsFile, File tempStatsFile, File oldStatsFile)
         throws IOException {
         try (PrintWriter writer = new PrintWriter(new FileWriter(tempStatsFile, false))) {
-            writer.print(StatsCounter.getStatFileContentString(session.username, "local", map));
+            writer.print(StatsCounter.getStatFileContentString(session.uuid, "local", map));
         }
         if (oldStatsFile.exists()) {
             oldStatsFile.delete();
@@ -107,7 +111,7 @@ public class StatsSyncher {
                         queuedLocalStatsChanges = readStatsFromFile(statsFile, statsFileTemp, statsFileOld);
                     }
                 } catch (Exception exception) {
-                    exception.printStackTrace();
+                    LOGGER.error("Unexpected exception in retrieval thread!", exception);
                 } finally {
                     busy = false;
                 }
@@ -125,7 +129,7 @@ public class StatsSyncher {
                 try {
                     saveStats(mapToSave, unsentStatsFile, unsentStatsFileTemp, unsentStatsFileOld);
                 } catch (Exception exception) {
-                    exception.printStackTrace();
+                    LOGGER.error("Unexpected exception in saving thread!", exception);
                 } finally {
                     busy = false;
                 }
@@ -139,7 +143,7 @@ public class StatsSyncher {
             try {
                 Thread.sleep(100L);
             } catch (InterruptedException interrupt) {
-                interrupt.printStackTrace();
+                LOGGER.warn("Interrupted!", interrupt);
             }
         }
 
@@ -147,7 +151,7 @@ public class StatsSyncher {
         try {
             saveStats(map, unsentStatsFile, unsentStatsFileTemp, unsentStatsFileOld);
         } catch (Exception exception) {
-            exception.printStackTrace();
+            LOGGER.error("Exception saving stats!", exception);
         } finally {
             busy = false;
         }
diff --git a/src/main/java/net/minecraft/core/block/BaseLeavesBlock.java b/src/main/java/net/minecraft/core/block/BaseLeavesBlock.java
index 2d4bc69bc..eaa111485 100644
--- a/src/main/java/net/minecraft/core/block/BaseLeavesBlock.java
+++ b/src/main/java/net/minecraft/core/block/BaseLeavesBlock.java
@@ -187,7 +187,7 @@ public abstract class BaseLeavesBlock extends Block
     
     private void removeLeaves(World world, int i, int j, int k)
     {
-        dropBlockWithCause(world, EnumDropCause.WORLD, i, j, k, world.getBlockMetadata(i, j, k), null);
+        dropBlockWithCause(world, EnumDropCause.WORLD, i, j, k, world.getBlockMetadata(i, j, k), null, null);
         world.setBlockWithNotify(i, j, k, 0);
     }
 
diff --git a/src/main/java/net/minecraft/core/block/BlastFurnaceBlock.java b/src/main/java/net/minecraft/core/block/BlastFurnaceBlock.java
index ab6f38d49..2e3f06200 100644
--- a/src/main/java/net/minecraft/core/block/BlastFurnaceBlock.java
+++ b/src/main/java/net/minecraft/core/block/BlastFurnaceBlock.java
@@ -1,5 +1,6 @@
 package net.minecraft.core.block;
 
+import com.mojang.logging.LogUtils;
 import net.minecraft.core.Global;
 import net.minecraft.core.block.entity.BlockEntity;
 import net.minecraft.core.block.entity.BlastFurnaceBlockEntity;
@@ -8,6 +9,7 @@ import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
+import org.slf4j.Logger;
 
 import java.util.Random;
 
@@ -19,6 +21,7 @@ import java.util.Random;
 
 public class BlastFurnaceBlock extends FurnaceBlock
 {
+    private static final Logger LOGGER = LogUtils.getLogger();
 
 	public BlastFurnaceBlock(String key, String namespaceId, int id, boolean flag)
     {
@@ -45,7 +48,7 @@ public class BlastFurnaceBlock extends FurnaceBlock
     {
         if (!world.isClientSide) {
             BlastFurnaceBlockEntity tileentityblastfurnace = (BlastFurnaceBlockEntity) world.getBlockEntity(x, y, z);
-            player.displayGUIFurnace(tileentityblastfurnace);
+            player.displayFurnaceScreen(tileentityblastfurnace);
         }
         return true;
     }
@@ -87,14 +90,14 @@ public class BlastFurnaceBlock extends FurnaceBlock
 
 	public static void updateFurnaceBlockState(boolean lit, World world, int x, int y, int z) {
 		int meta = world.getBlockMetadata(x, y, z);
-		BlockEntity tileentity = world.getBlockEntity(x, y, z);
-		if(tileentity == null) {
+		BlockEntity blockEntity = world.getBlockEntity(x, y, z);
+		if(blockEntity == null) {
 			String msg = "Blast Furnace is missing Tile Entity at x: "+x+" y: "+y+" z: "+z+", block will be removed!";
 			if(Global.BUILD_CHANNEL.isUnstableBuild()) {
 				throw new RuntimeException(msg);
 			}
 			world.setBlockWithNotify(x, y, z, 0);
-			System.out.println(msg);
+            LOGGER.warn(msg);
 			return;
 		}
 		keepFurnaceInventory = true;
@@ -105,8 +108,8 @@ public class BlastFurnaceBlock extends FurnaceBlock
 		}
 		keepFurnaceInventory = false;
 		world.setBlockMetadataWithNotify(x, y, z, meta);
-		tileentity.validate();
-		world.setBlockTileEntity(x, y, z, tileentity);
+		blockEntity.validate();
+		world.setBlockTileEntity(x, y, z, blockEntity);
 	}
 
     @Override
diff --git a/src/main/java/net/minecraft/core/block/Block.java b/src/main/java/net/minecraft/core/block/Block.java
index 23e918c3f..068207e88 100644
--- a/src/main/java/net/minecraft/core/block/Block.java
+++ b/src/main/java/net/minecraft/core/block/Block.java
@@ -583,36 +583,36 @@ public class Block
         return false;
     }
 
-    public void harvestBlock(World world, Player entityplayer, int x, int y, int z, int meta, BlockEntity blockEntity)
+    public void harvestBlock(World world, Player player, int x, int y, int z, int meta, BlockEntity blockEntity)
     {
-		entityplayer.addStat(getStat(StatList.STAT_MINED), 1);
+    	player.addStat(getStat(StatList.STAT_MINED), 1);
 
-		ItemStack heldItemStack = entityplayer.inventory.getCurrentItem();
+		ItemStack heldItemStack = player.inventory.getCurrentItem();
 		Item heldItem = heldItemStack != null ? Item.itemsList[heldItemStack.itemID] : null;
 
         if (heldItem != null)
         {
-            if (heldItem.isSilkTouch() && entityplayer.canHarvestBlock(this))
+            if (heldItem.isSilkTouch() && player.canHarvestBlock(this))
             {
-                dropBlockWithCause(world, EnumDropCause.SILK_TOUCH, x, y, z, meta, blockEntity);
+                dropBlockWithCause(world, EnumDropCause.SILK_TOUCH, x, y, z, meta, blockEntity, player);
                 return;
             }
             else if (heldItem instanceof ToolShearsItem && (this.hasTag(BlockTags.SHEARS_DO_SILK_TOUCH) || this.hasTag(BlockTags.MINEABLE_BY_SHEARS)))
             {
                 ToolShearsItem heldShears = (ToolShearsItem) heldItem;
-                dropBlockWithCause(world, EnumDropCause.SILK_TOUCH, x, y, z, meta, blockEntity);
-                heldShears.onBlockSheared(entityplayer, heldItemStack);
+                dropBlockWithCause(world, EnumDropCause.SILK_TOUCH, x, y, z, meta, blockEntity, player);
+                heldShears.onBlockSheared(player, heldItemStack);
                 return;
             }
         }
 
-        if (entityplayer.canHarvestBlock(this))
+        if (player.canHarvestBlock(this))
         {
-            dropBlockWithCause(world, EnumDropCause.PROPER_TOOL, x, y, z, meta, blockEntity);
+            dropBlockWithCause(world, EnumDropCause.PROPER_TOOL, x, y, z, meta, blockEntity, player);
         }
         else
         {
-            dropBlockWithCause(world, EnumDropCause.IMPROPER_TOOL, x, y, z, meta, blockEntity);
+            dropBlockWithCause(world, EnumDropCause.IMPROPER_TOOL, x, y, z, meta, blockEntity, player);
         }
 	}
 
@@ -621,37 +621,37 @@ public class Block
         return asItem().getStat(statID);
     }
 
-    public void dropBlockWithCause(World world, EnumDropCause cause, int x, int y, int z, int meta, BlockEntity blockEntity)
-    {
-        if (world.isClientSide) return;
-
-        ItemStack[] drops = getBreakResult(world, cause, x, y, z, meta, blockEntity);
-        if (dropOverride > 0){
-            drops = new ItemStack[]{Item.itemsList[dropOverride].getDefaultStack()};
-        }
-        if (drops != null && drops.length > 0)
-        {
-            for (ItemStack drop : drops)
-            {
-                if (drop != null)
-                {
-                	if(ItemEntity.enableItemClumping)
-                	{
-                		world.dropItem(x, y, z, drop.copy());
-                	}
-                	else
-                	{
-                        for (int i = 0; i < drop.stackSize; i++)
-                        {
-                        	ItemStack drop1 = drop.copy();
-                        	drop1.stackSize = 1;
-                            world.dropItem(x, y, z, drop1);
-                        }
-                	}
-                }
-            }
-        }
-    }
+	public void dropBlockWithCause(World world, EnumDropCause cause, int x, int y, int z, int meta, BlockEntity blockEntity, Player player) {
+		if(world.isClientSide)
+			return;
+
+		ItemStack[] drops = getBreakResult(world, cause, x, y, z, meta, blockEntity);
+		if(dropOverride > 0) {
+			drops = new ItemStack[] { Item.itemsList[dropOverride].getDefaultStack() };
+		}
+		if(drops != null && drops.length > 0) {
+			for(ItemStack drop : drops) {
+				if(drop == null) {
+					continue;
+				}
+				if(hasTag(BlockTags.INSTANT_PICKUP) && player != null) {
+					player.inventory.insertItem(drop, true);
+					if(drop.stackSize <= 0) {
+						continue;
+					}
+				}
+				if(ItemEntity.enableItemClumping) {
+					world.dropItem(x, y, z, drop.copy());
+				}else {
+					for(int i = 0; i < drop.stackSize; i++) {
+						ItemStack drop1 = drop.copy();
+						drop1.stackSize = 1;
+						world.dropItem(x, y, z, drop1);
+					}
+				}
+			}
+		}
+	}
 
     public boolean canBlockStay(World world, int x, int y, int z)
     {
diff --git a/src/main/java/net/minecraft/core/block/Blocks.java b/src/main/java/net/minecraft/core/block/Blocks.java
index 2c7adf37e..000a8528f 100644
--- a/src/main/java/net/minecraft/core/block/Blocks.java
+++ b/src/main/java/net/minecraft/core/block/Blocks.java
@@ -541,8 +541,8 @@ public final class Blocks {
         WOOL = new WoolBlock("wool", "minecraft:block/wool", 110).withSound(BlockSounds.CLOTH).withHardness(0.8F).withDisabledNeighborNotifyOnMetadataChange()
             .setBlockItem((b) -> new PaintedBlockItem(b, false))
             .withTags(BlockTags.MINEABLE_BY_SHEARS);
-        ROPE = new RopeBlock("rope", "minecraft:block/rope", 111).withSound(BlockSounds.CLOTH).withHardness(0.0F).withDisabledNeighborNotifyOnMetadataChange().setStatParent(() -> Items.ROPE)
-            .withTags(BlockTags.BROKEN_BY_FLUIDS, BlockTags.NOT_IN_CREATIVE_MENU, BlockTags.PREVENT_MOB_SPAWNS, BlockTags.CAN_HANG_OFF);
+        ROPE = new RopeBlock("rope", "minecraft:block/rope", 111).withSound(BlockSounds.CLOTH).withHardness(0.01F).withDisabledNeighborNotifyOnMetadataChange().setStatParent(() -> Items.ROPE)
+            .withTags(BlockTags.BROKEN_BY_FLUIDS, BlockTags.NOT_IN_CREATIVE_MENU, BlockTags.PREVENT_MOB_SPAWNS, BlockTags.CAN_HANG_OFF, BlockTags.INSTANT_PICKUP);
 
         BRICK_CLAY = new Block("brick.clay", "minecraft:block/brick_clay", 120, Material.stone).withSound(BlockSounds.STONE).withHardness(3.0F).withBlastResistance(10F).withOverrideColor(MaterialColor.brick)
             .withTags(BlockTags.MINEABLE_BY_PICKAXE);
@@ -775,9 +775,9 @@ public final class Blocks {
             .withTags(BlockTags.BROKEN_BY_FLUIDS, BlockTags.PLANTABLE_IN_JAR);
 
         TALLGRASS = new TallGrassBlock("tallgrass", "minecraft:block/tallgrass", 320).setKilledByWeather().withSound(BlockSounds.GRASS).withHardness(0.0F)
-            .withTags(BlockTags.BROKEN_BY_FLUIDS, BlockTags.PLACE_OVERWRITES, BlockTags.SHEARS_DO_SILK_TOUCH);
+            .withTags(BlockTags.BROKEN_BY_FLUIDS, BlockTags.PLACE_OVERWRITES, BlockTags.SHEARS_DO_SILK_TOUCH, BlockTags.SHEEPS_FAVOURITE_BLOCK);
         TALLGRASS_FERN = new TallGrassBlock("tallgrass.fern", "minecraft:block/tallgrass_fern", 321).setKilledByWeather().withSound(BlockSounds.GRASS).withHardness(0.0F)
-            .withTags(BlockTags.BROKEN_BY_FLUIDS, BlockTags.PLACE_OVERWRITES, BlockTags.SHEARS_DO_SILK_TOUCH, BlockTags.PLANTABLE_IN_JAR);
+            .withTags(BlockTags.BROKEN_BY_FLUIDS, BlockTags.PLACE_OVERWRITES, BlockTags.SHEARS_DO_SILK_TOUCH, BlockTags.PLANTABLE_IN_JAR, BlockTags.SHEEPS_FAVOURITE_BLOCK);
         DEADBUSH = new DeadBushBlock("deadbush", "minecraft:block/deadbush", 322).withSound(BlockSounds.GRASS).withHardness(0.0F).withOverrideColor(MaterialColor.wood)
             .withTags(BlockTags.BROKEN_BY_FLUIDS, BlockTags.PLACE_OVERWRITES, BlockTags.SHEARS_DO_SILK_TOUCH, BlockTags.PLANTABLE_IN_JAR);
         SPINIFEX = new SpinifexBlock("spinifex", "minecraft:block/spinifex", 323).withSound(BlockSounds.GRASS).withHardness(0.0F)
@@ -787,22 +787,22 @@ public final class Blocks {
             .withTags(BlockTags.BROKEN_BY_FLUIDS, BlockTags.PLACE_OVERWRITES, BlockTags.SHEARS_DO_SILK_TOUCH);
 
         FLOWER_YELLOW = new FlowerBlock("flower.yellow", "minecraft:block/flower_yellow", 330).setKilledByWeather().setBonemealable().withSound(BlockSounds.GRASS).withHardness(0.0F).withOverrideColor(MaterialColor.paintedYellow)
-            .withTags(BlockTags.BROKEN_BY_FLUIDS, BlockTags.PLANTABLE_IN_JAR);
+            .withTags(BlockTags.BROKEN_BY_FLUIDS, BlockTags.PLANTABLE_IN_JAR, BlockTags.SHEEPS_FAVOURITE_BLOCK);
         FLOWER_RED = new FlowerBlock("flower.red", "minecraft:block/flower_red", 331).setKilledByWeather().setBonemealable().withSound(BlockSounds.GRASS).withHardness(0.0F).withOverrideColor(MaterialColor.paintedRed)
-            .withTags(BlockTags.BROKEN_BY_FLUIDS, BlockTags.PLANTABLE_IN_JAR);
+            .withTags(BlockTags.BROKEN_BY_FLUIDS, BlockTags.PLANTABLE_IN_JAR, BlockTags.SHEEPS_FAVOURITE_BLOCK);
         FLOWER_PINK = new FlowerBlock("flower.pink", "minecraft:block/flower_pink", 332).setKilledByWeather().setBonemealable().withSound(BlockSounds.GRASS).withHardness(0.0F).withOverrideColor(MaterialColor.paintedPink)
-            .withTags(BlockTags.BROKEN_BY_FLUIDS, BlockTags.PLANTABLE_IN_JAR);
+            .withTags(BlockTags.BROKEN_BY_FLUIDS, BlockTags.PLANTABLE_IN_JAR, BlockTags.SHEEPS_FAVOURITE_BLOCK);
         FLOWER_PURPLE = new FlowerBlock("flower.purple", "minecraft:block/flower_purple", 333).setKilledByWeather().setBonemealable().withSound(BlockSounds.GRASS).withHardness(0.0F).withOverrideColor(MaterialColor.paintedPurple)
-            .withTags(BlockTags.BROKEN_BY_FLUIDS, BlockTags.PLANTABLE_IN_JAR);
+            .withTags(BlockTags.BROKEN_BY_FLUIDS, BlockTags.PLANTABLE_IN_JAR, BlockTags.SHEEPS_FAVOURITE_BLOCK);
         FLOWER_LIGHT_BLUE = new FlowerBlock("flower.lightblue", "minecraft:block/flower_light_blue", 334).setKilledByWeather().setBonemealable().withSound(BlockSounds.GRASS).withHardness(0.0F).withOverrideColor(MaterialColor.paintedLightblue)
-            .withTags(BlockTags.BROKEN_BY_FLUIDS, BlockTags.PLANTABLE_IN_JAR);
+            .withTags(BlockTags.BROKEN_BY_FLUIDS, BlockTags.PLANTABLE_IN_JAR, BlockTags.SHEEPS_FAVOURITE_BLOCK);
         FLOWER_ORANGE = new FlowerBlock("flower.orange", "minecraft:block/flower_orange", 335).setKilledByWeather().setBonemealable().withSound(BlockSounds.GRASS).withHardness(0.0F).withOverrideColor(MaterialColor.paintedOrange)
-            .withTags(BlockTags.BROKEN_BY_FLUIDS, BlockTags.PLANTABLE_IN_JAR);
+            .withTags(BlockTags.BROKEN_BY_FLUIDS, BlockTags.PLANTABLE_IN_JAR, BlockTags.SHEEPS_FAVOURITE_BLOCK);
 
         MUSHROOM_BROWN = new MushroomBlock("mushroom.brown", "minecraft:block/mushroom_brown", 340).withSound(BlockSounds.GRASS).withHardness(0.0F).withLightEmission(0.125F).withOverrideColor(MaterialColor.paintedBrown)
-            .withTags(BlockTags.BROKEN_BY_FLUIDS, BlockTags.PLANTABLE_IN_JAR);
+            .withTags(BlockTags.BROKEN_BY_FLUIDS, BlockTags.PLANTABLE_IN_JAR, BlockTags.PIGS_FAVOURITE_BLOCK);
         MUSHROOM_RED = new MushroomBlock("mushroom.red", "minecraft:block/mushroom_red", 341).withSound(BlockSounds.GRASS).withHardness(0.0F).withOverrideColor(MaterialColor.paintedRed)
-            .withTags(BlockTags.BROKEN_BY_FLUIDS, BlockTags.PLANTABLE_IN_JAR);
+            .withTags(BlockTags.BROKEN_BY_FLUIDS, BlockTags.PLANTABLE_IN_JAR, BlockTags.PIGS_FAVOURITE_BLOCK);
 
 
         ORE_COAL_STONE = new CoalOreBlock("ore.coal.stone", "minecraft:block/ore_coal_stone", 350, STONE.id, Material.stone).withSound(BlockSounds.STONE).withHardness(3F).withBlastResistance(5F)
diff --git a/src/main/java/net/minecraft/core/block/ButtonBlock.java b/src/main/java/net/minecraft/core/block/ButtonBlock.java
index 4f98b6905..df7864c37 100644
--- a/src/main/java/net/minecraft/core/block/ButtonBlock.java
+++ b/src/main/java/net/minecraft/core/block/ButtonBlock.java
@@ -165,7 +165,7 @@ public class ButtonBlock extends Block
             }
             if(flag)
             {
-                dropBlockWithCause(world, EnumDropCause.WORLD, x, y, z, i1, null);
+                dropBlockWithCause(world, EnumDropCause.WORLD, x, y, z, i1, null, null);
                 world.setBlockWithNotify(x, y, z, 0);
             }
         }
@@ -175,7 +175,7 @@ public class ButtonBlock extends Block
     {
         if(!canPlaceBlockAt(world, x, y, z))
         {
-            dropBlockWithCause(world, EnumDropCause.WORLD, x, y, z, world.getBlockMetadata(x, y, z), null);
+            dropBlockWithCause(world, EnumDropCause.WORLD, x, y, z, world.getBlockMetadata(x, y, z), null, null);
             world.setBlockWithNotify(x, y, z, 0);
             return false;
         }
